/*******************************************************************
 *
 *	File:		Dialogs.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __DIALOGS_H
#define __DIALOGS_H

#include "ScapEng.h"
#include <eikdialg.h>

class CEikChoiceList;
class CEikCheckBox;
class CQikNumberEditor;
class CEikEdwin;

class CGeneralOptionsDialog : public CEikDialog
{
public:
	CGeneralOptionsDialog(TSCapOptions& aSCapOptions);

protected:
	virtual TBool OkToExitL(TInt aButtonId);
	virtual void PreLayoutDynInitL();
	virtual void PostLayoutDynInitL();
	virtual void HandleControlStateChangeL(TInt aControlId);

	void SetUserDefinedL();
	void SelectAudioFileL();

	TSCapOptions&	iSCapOptions;

	CEikChoiceList*		iHotkeyChoiceList;
	CEikChoiceList*		iStopCaptureChoiceList;

	CEikCheckBox*		iVisualFeedbackCheckBox;
	CEikChoiceList*		iAudibleFeedbackChoiceList;
};


class CImageOptionsDialog : public CEikDialog
{
public:
	CImageOptionsDialog(TSCapOptions& aSCapOptions);

protected:
	virtual TBool OkToExitL(TInt aButtonId);
	virtual void PreLayoutDynInitL();
	virtual void PostLayoutDynInitL();
	virtual void HandleControlStateChangeL(TInt aControlId);
	void UpdateImageQualityState();
	TSCapOptions&	iSCapOptions;

	CEikChoiceList*		iImageChoiceList;
	CEikChoiceList*		iStorageLocationChoiceList;
	CQikNumberEditor*	iImageQualityEditor;
	CEikEdwin*			iBaseFileNameEdwin ;
};

#endif			/* __DIALOGS_H */
