/*******************************************************************
 *
 *	File:		SCap.h
 *
 *	Author:		Peter van Sebille (peter@yipton.net)
 *
 *	(c) Copyright 2003, Peter van Sebille
 *	All Rights Reserved
 *
 *******************************************************************/

#ifndef __SCAP_H
#define __SCAP_H

#include <coecntrl.h>
#include <coeccntx.h>
#include <coemain.h>

#include <eikappui.h>
#include <eikapp.h>
#include <eikdoc.h>

#include "scap.hrh"
#include "scapeng.h"

const TUid KUidSCapApp = { 0x10009BBC };

class CWsBitmap;
class CMyBusyMsgWindow;

class CSCapDocument : public CEikDocument
{
public:
	~CSCapDocument();
	CSCapDocument(CEikApplication& aApp);
	void ConstructL();

private: // from CEikDocument
	CEikAppUi* CreateAppUiL();
};


class CSCapAppView : public CCoeControl, public MCoeControlBrushContext
{
public:
	~CSCapAppView();
	void ConstructL(const TRect& aRect);
private:
	void Draw(const TRect& /*aRect*/) const;

	CWsBitmap*	iBgImage;
	TPoint		iImagePosition;
};


class CSCapAppUi : public CEikAppUi, public MSaveImageObserver
{
public:
	CSCapAppUi(){}
	void ConstructL();
	~CSCapAppUi();


public:			// implements MSaveImageObserver
	void StartedSavingImage();
	void FinishedSavingImage();

protected: // from CEikAppUi
	void HandleCommandL(TInt aCommand);
	void DynInitMenuPaneL(TInt aMenuId, CEikMenuPane* aMenuPane);
	void DynInitSCapMenuPaneL(CEikMenuPane* aMenuPane);

	void DisplayAboutDialogL();
	void DisplayGeneralOptionsDialogL();
	void DisplayImageOptionsDialogL();

	void HandleWsEventL(const TWsEvent& aEvent, CCoeControl* aDestination);

private:
	CSCapAppView*		iAppView;
	CSCapEngine*		iSCapEngine;
	RWindowGroup		iWinGroup;
	CMyBusyMsgWindow*	iMyBusyMsgWindow;
};



class CSCapApplication : public CEikApplication
	{
private: // from CApaApplication
	CApaDocument* CreateDocumentL();
	TUid AppDllUid() const;
	};

#endif
